import { CookieSerializeOptions } from 'cookie';
import { IncomingMessage, ServerResponse } from 'http';

declare type password = string | {
    id: number;
    password: string;
}[];
interface IronSessionOptions {
    cookieName: string;
    password: password;
    ttl?: number;
    cookieOptions?: CookieSerializeOptions;
}
interface IronSession {
    set: <T = unknown>(name: string, value: T) => T;
    get: <T = unknown>(name: string) => T | undefined;
    unset: (name: string) => void;
    destroy: () => void;
    save: () => Promise<string>;
}
declare function getIronSession<RequestType extends IncomingMessage, ResponseType extends ServerResponse>(req: RequestType, res: ResponseType, userOptions: IronSessionOptions): Promise<{
    set: <T = any>(name: string, value: T) => T;
    get: (name?: string | undefined) => any;
    unset: (name: string) => void;
    save(): Promise<string>;
    destroy(): void;
}>;

export { IronSession, IronSessionOptions, getIronSession };
