import { NextApiRequest, NextApiResponse, GetServerSidePropsResult, GetServerSidePropsContext } from 'next';
import { IronSession, IronSessionOptions } from './index';
import 'cookie';
import 'http';

interface NextApiRequestWithIronSession extends NextApiRequest {
    session: IronSession;
}
declare type NextApiHandlerWithIronSession<T = unknown> = (req: NextApiRequestWithIronSession, res: NextApiResponse<T>) => void | Promise<void>;
interface NextGetSeverSideContextWithIronSession extends GetServerSidePropsContext {
    req: NextApiRequestWithIronSession;
}
declare type NextGetServerSidePropsHandlerWithIronSession<P> = (context: NextGetSeverSideContextWithIronSession) => Promise<GetServerSidePropsResult<P>>;
declare function withIronSessionApiRoute(handler: NextApiHandlerWithIronSession, options: IronSessionOptions): NextApiHandlerWithIronSession;
declare function withIronSessionSsr<P>(handler: NextGetServerSidePropsHandlerWithIronSession<P>, options: IronSessionOptions): NextGetServerSidePropsHandlerWithIronSession<P>;

export { NextApiHandlerWithIronSession, NextApiRequestWithIronSession, NextGetServerSidePropsHandlerWithIronSession, withIronSessionApiRoute, withIronSessionSsr };
